#include <stdlib.h>
#include <i86.h>
#include "mdll.h"

void (*parentfunc)(void);
int (*dllWalk) (mdllHandle mdllH, 
		int (* iter)(void * parm, char * name), void * parm);

void dos_put (char *s) {
    union REGS inregs;
    int i;

    for (i=0; s[i]; i++) ;
    s[i] = '$';

    inregs.h.ah = 9;
    inregs.x.edx = (long)s;
    int386 (0x21, &inregs, &inregs);

    s[i] = '\0';
}

void childfunc (void) {
    dos_put("Hello from child, called from parent.\n\r");
    parentfunc();
}

static int dllApiIter (void * nothing, char * name) {
    dos_put (name);
    dos_put ("\n\r");
    return 0;
}


int __export mdll_entry (void *(*MDLL_Import)(mdllHandle, char *name), 
			 int (*MDLL_Export)(mdllHandle, char *name,void *obj),
                         mdllHandle mdllH) {
int ret = 0;

    /* Import the expected parent function */
    parentfunc = MDLL_Import (mdllH, "parentfunc()");
    if (parentfunc == NULL) return -__LINE__;

    dllWalk = MDLL_Import (mdllH, "dllwalk()");
    if (dllWalk) dllWalk (mdllH, dllApiIter, (void *)0);

    /* Perform all intended exports here */
    ret = MDLL_Export (mdllH, "childfunc()", childfunc);
    return ret;
}

